#
#-------------------------------------------------------------------------------
# @(#) config-nokia-nss/M13.5/UserConfig.pm config-nokia-nss_d1.0.0.latest:cset.003273:4:4@(#)
#-------------------------------------------------------------------------------
#
# This perl module contains the configuration information for this parser.
# If you don't understand the format of this configuration file DON'T TOUCH IT.
#
# My Vendor Interface
#
# Copyright (C) IBM Corporation 2008
#
package UserConfig;

# Company Name: 

@ISA = qw(Exporter);
@EXPORT = qw(postparser_config);

#use diagnostics;
use strict;
use Exporter ();

#-------------------------------------------------------------------------------

my @rules = (
#-------------------------------------------------------------------------------
# Modify/Add rules here
#-------------------------------------------------------------------------------{
{
        RULE_TYPE                               => 'JOIN',
        RULE_DESC                               => 'Join TCGRP pif',
        INPUT_FILE_DESCRIPTION                  => [ '^TC-#-(\d{4}-\d{2}-\d{2}-#-\d{2}:\d{2})-#-\d{2}-#-\w*-#-\w*-#-I.pif' ],
        COUNTERS_TO_JOIN_ON                     => ['msc_id','tcat_id','startDate','startTime' ],
        HEADER_COUNTERS_TO_USE_IN_OUTPUT_FILENAME => [ 'startDate','startTime' ],
        OUTPUT_BLOCK_NAME                       => 'TCGRP',
        OUTPUT_FILENAME_START                   => 'TCGRP',
        PRODUCE_PIF                             => 'True',
        PRODUCE_LIF                             => 0,
        NON_APPLICABLE_HEADER_COUNTERS          => [],
        REDUNDANT_COUNTERS                      => [],
        HOURS_TO_WAIT_FOR_PARTNER_FILES         => 0.1,
},


{
	RULE_TYPE	        => 'ACCUMULATE' ,
	RULE_DESC	        => 'Accumuluate for TC',
        INPUT_FILE_DESCRIPTION  => ['^TCGRP-#-\d{4}-\d{2}-\d{2}-#-\d{2}:\d{2}-#-\w*-#-J.pif'],
        PRODUCE_PIF	        => 'True' ,
	PRODUCE_LIF	        => 0,
	COUNTERS_TO_SORT_ON     => ['msc_id'],
	REDUNDANT_DATA_COUNTERS => ['tcat_id','plmn_id','TCGRP_NUM_IN_SUM'],
	OUTPUT_BLOCK_NAME       => 'TCGRP',
	APPEND_STR	        => '',
},

{
    RULE_TYPE                           => 'INFOINSERT',
    RULE_DESC                           => 'Insert snet_id, spc_id and slsn_id from MTPNHLR block',   
    INPUT_FILE_DESCRIPTION              => ['^MTPHLR-#-\d{4}-\d{2}-\d{2}-#-\d{2}:\d{2}-#-\d{2}-#-\w*-#-\w*-#-I.pif',
                                             '^SLHLR-#-\d{4}-\d{2}-\d{2}-#-\d{2}:\d{2}-#-\d{2}-#-\w*-#-\w*-#-I.pif', 
                                             '^SLPHLR-#-\d{4}-\d{2}-\d{2}-#-\d{2}:\d{2}-#-\d{2}-#-\w*-#-\w*-#-I.pif',],  
    HEADER_NAMES_USED_TO_ID_DATA_RECORD => ['startDate','REGION_ID','NETWORK_ID'],
    NAMES_USED_TO_ID_DATA_RECORD        => ['hlr_id','sln_id'],
    INFO_FILE_DESCRIPTION               => ['MTPNHLR-#-\d{4}-\d{2}-\d{2}-#-\d{2}:\d{2}-#-\d{2}-#-\w*-#-\w*-#-I.pif'],
    HEADER_NAMES_USED_TO_ID_INFORMATION => ['startDate','REGION_ID','NETWORK_ID'],
    NAMES_USED_TO_ID_INFORMATION        => ['hlr_id','sln_id'],
    REDUNDANT_DATA_COUNTERS             => [],
    ONLY_INSERT                         => ['snet_id','spc_id','slsn_id'],
    WRITE_DATA_LINE                     => 'True',
    PRODUCE_PIF                         => 'True',
},

{
    RULE_TYPE                           => 'INFOINSERT',
    RULE_DESC                           => 'Insert snet_id, spc_id and slsn_id from MTPNMSC block',   
    INPUT_FILE_DESCRIPTION              => ['^MTPMSC-#-\d{4}-\d{2}-\d{2}-#-\d{2}:\d{2}-#-\d{2}-#-\w*-#-\w*-#-I.pif',
                                             '^SLMSC-#-\d{4}-\d{2}-\d{2}-#-\d{2}:\d{2}-#-\d{2}-#-\w*-#-\w*-#-I.pif', 
                                             '^SLPMSC-#-\d{4}-\d{2}-\d{2}-#-\d{2}:\d{2}-#-\d{2}-#-\w*-#-\w*-#-I.pif',],  
    HEADER_NAMES_USED_TO_ID_DATA_RECORD => ['startDate','REGION_ID','NETWORK_ID'],
    NAMES_USED_TO_ID_DATA_RECORD        => ['msc_id','sln_id'],
    INFO_FILE_DESCRIPTION               => ['MTPNMSC-#-\d{4}-\d{2}-\d{2}-#-\d{2}:\d{2}-#-\d{2}-#-\w*-#-\w*-#-I.pif'],
    HEADER_NAMES_USED_TO_ID_INFORMATION => ['startDate','REGION_ID','NETWORK_ID'],
    NAMES_USED_TO_ID_INFORMATION        => ['msc_id','sln_id'],
    REDUNDANT_DATA_COUNTERS             => [],
    ONLY_INSERT                         => ['snet_id','spc_id','slsn_id'],
    WRITE_DATA_LINE                     => 'True',
    PRODUCE_PIF                         => 'True',
},

{
    RULE_TYPE                           => 'INFOINSERT',
    RULE_DESC                           => 'Insert snet_id, spc_id and slsn_id from MTPNSRR block',   
    INPUT_FILE_DESCRIPTION              => ['^MTPSRR-#-\d{4}-\d{2}-\d{2}-#-\d{2}:\d{2}-#-\d{2}-#-\w*-#-\w*-#-I.pif',
                                             '^SLSRR-#-\d{4}-\d{2}-\d{2}-#-\d{2}:\d{2}-#-\d{2}-#-\w*-#-\w*-#-I.pif', 
                                             '^SLPSRR-#-\d{4}-\d{2}-\d{2}-#-\d{2}:\d{2}-#-\d{2}-#-\w*-#-\w*-#-I.pif',],  
    HEADER_NAMES_USED_TO_ID_DATA_RECORD => ['startDate','REGION_ID','NETWORK_ID'],
    NAMES_USED_TO_ID_DATA_RECORD        => ['srr_id','sln_id'],
    INFO_FILE_DESCRIPTION               => ['MTPNSRR-#-\d{4}-\d{2}-\d{2}-#-\d{2}:\d{2}-#-\d{2}-#-\w*-#-\w*-#-I.pif'],
    HEADER_NAMES_USED_TO_ID_INFORMATION => ['startDate','REGION_ID','NETWORK_ID'],
    NAMES_USED_TO_ID_INFORMATION        => ['srr_id','sln_id'],
    REDUNDANT_DATA_COUNTERS             => [],
    ONLY_INSERT                         => ['snet_id','spc_id','slsn_id'],
    WRITE_DATA_LINE                     => 'True',
    PRODUCE_PIF                         => 'True',
},

{
    RULE_TYPE                           => 'INFOINSERT',
    RULE_DESC                           => 'Insert snet_id, spc_id and slsn_id from STAMSC block',   
    INPUT_FILE_DESCRIPTION              => ['^ACVSPC-#-\d{4}-\d{2}-\d{2}-#-\d{2}:\d{2}-#-\d{2}-#-\w*-#-\w*-#-I.pif',],
    HEADER_NAMES_USED_TO_ID_DATA_RECORD => ['REGION_ID','NETWORK_ID'],
    NAMES_USED_TO_ID_DATA_RECORD        => ['msc_id','spc_id'],
    INFO_FILE_DESCRIPTION               => ['STAMSC-#-\d{4}-\d{2}-\d{2}-#-\d{2}:\d{2}-#-\d{2}-#-\w*-#-\w*-#-I.pif'],
    HEADER_NAMES_USED_TO_ID_INFORMATION => ['REGION_ID','NETWORK_ID'],
    NAMES_USED_TO_ID_INFORMATION        => ['msc_id','spc_id'],
    REDUNDANT_DATA_COUNTERS             => [],
    ONLY_INSERT                         => ['snet_id'],
    WRITE_DATA_LINE                     => 'True',
    PRODUCE_PIF                         => 'True',
},

{
    RULE_TYPE                           => 'INFOINSERT',
    RULE_DESC                           => 'Insert snet_id from STAHLR block',   
    INPUT_FILE_DESCRIPTION              => ['^ACHSPC-#-\d{4}-\d{2}-\d{2}-#-\d{2}:\d{2}-#-\d{2}-#-\w*-#-\w*-#-I.pif',],
    HEADER_NAMES_USED_TO_ID_DATA_RECORD => ['REGION_ID','NETWORK_ID'],
    NAMES_USED_TO_ID_DATA_RECORD        => ['hlr_id','spc_id'],
    INFO_FILE_DESCRIPTION               => ['STAHLR-#-\d{4}-\d{2}-\d{2}-#-\d{2}:\d{2}-#-\d{2}-#-\w*-#-\w*-#-I.pif'],
    HEADER_NAMES_USED_TO_ID_INFORMATION => ['REGION_ID','NETWORK_ID'],
    NAMES_USED_TO_ID_INFORMATION        => ['hlr_id','spc_id'],
    REDUNDANT_DATA_COUNTERS             => [],
    ONLY_INSERT                         => ['snet_id'],
    WRITE_DATA_LINE                     => 'True',
    PRODUCE_PIF                         => 'True',
},


#---------------------------------------------------------------------------------------
# To round down the (1) interval time to nearest 15 minute , eg interval 59 to interval 60
#                   (2) startTime     to nearest 15 minute
# For rounding interval , this apply only to interval which is below 60
#--------------------------------------------------------------------------------------
{
	RULE_TYPE	=> 'PERLIZE' ,
	RULE_DESC	=> 'To round dowm interval and startime',
	INPUT_FILE_DESCRIPTION => '.*\.pif',
	HEADER_COUNTERS_OP      => sub {
		my $h_ref = shift;

		#------------------------------------------
		# Rounding up the interval
		#------------------------------------------
		my $interval_old = $h_ref->{'interval'};
		my $interval_new = $interval_old ;
		if($interval_old < 60){
			my $remainder_int = ($interval_old % 15) ;
			if ($remainder_int > 0 ){
				$interval_new = $interval_old + (15 - $remainder_int);
				$h_ref->{'interval'} = $interval_new;
			}
		}

		#-----------------------------------------
		# Rounding down the starttime
		#----------------------------------------
		my @hhmm = split(":",$h_ref->{'startTime'}); 
		my $hh   = $hhmm[0];
		my $mm   = $hhmm[1];
		my $interval_mm;
		my $remainder_mm=$mm%$interval_new ;
		if($remainder_mm > 0){
			$interval_mm = ($mm *1) - $remainder_mm ;
			if($interval_mm eq '0'){
				$interval_mm="00";
			}
			$h_ref->{'startTime'} = "$hh:$interval_mm" ;
		}
		
		return 0;
	},
	FILENAME_SUFFIX   => 'PZ' ,
	PRODUCE_PIF	  => 'True',
},

{
        RULE_TYPE       => 'PIF_REMOVE',
        RULES_DESC      => 'Remove initial PIF',
        INPUT_FILE_DESCRIPTION => ['.*-#-A\.pif','.*-#-I\.pif',
                                   'MTPHLR-.*-#-I-#-PZ\.pif',
                                   'SLHLR-.*-#-I-#-PZ\.pif',
				   'SLPHLR-.*-#-I-#-PZ\.pif',
                                   'MTPMSC-.*-#-I-#-PZ\.pif',
                                   'SLMSC-.*-#-I-#-PZ\.pif',
				   'SLPMSC-.*-#-I-#-PZ\.pif',
                                   'MTPSRR-.*-#-I-#-PZ\.pif',
                                   'SLSRR-.*-#-I-#-PZ\.pif',
				   'SLPSRR-.*-#-I-#-PZ\.pif',
				   'ACVSPC-.*-#-I-#-PZ\.pif',
				   'ACHSPC-.*-#-I-#-PZ\.pif',],
},

#{
#        RULE_TYPE       => 'PIF_2_OUTPUT',
#        RULES_DESC      => 'Pif to Output',
#        INPUT_FILE_DESCRIPTION => '.*',
#        PRODUCE_PIF     => 0,
#        OUTPUT_FORMAT   => 'LIF_Writer',
#},
{
     RULE_TYPE               => 'BATCHFILES' ,
     RULE_DESC               => 'Batch PIF file By Block Name' ,
     INPUT_FILE_DESCRIPTION  => ['(\w+-#-\d{4}-\d{2}-\d{2})-#-\d{2}:\d{2}-#-.+-#-.+-#-.+-#-I-#-S-#-PZ\.pif'],
     OUTPUT_FORMAT           => 'LIF_Writer',
     OUTPUT_FILENAME_START   => 'BATCHED',
},



{
     RULE_TYPE	             => 'BATCHFILES' ,
     RULE_DESC               => 'Batch PIF file By Block Name' ,
     INPUT_FILE_DESCRIPTION  => ['(\w+-#-\d{4}-\d{2}-\d{2})-#-\d{2}:\d{2}-#-.+-#-.+-#-.+-#-I-#-PZ\.pif'],
     OUTPUT_FORMAT	     => 'LIF_Writer',
     OUTPUT_FILENAME_START   => 'BATCHED',
},



{
	
     RULE_TYPE	             => 'BATCHFILES' ,
     RULE_DESC               => 'Batch PIF file By Block Name' ,
     INPUT_FILE_DESCRIPTION  => ['(TCGRP-#-\d{4}-\d{2}-\d{2})-#-\d{2}:\d{2}-#-.*-#-J-#-TCGRP-#-A-#-PZ.pif'],
     OUTPUT_FORMAT	     => 'LIF_Writer',
     OUTPUT_FILENAME_START   => 'BATCHED',
}


);

sub postparser_config {
	return \@rules;
}

1;
